/**
 *
 */
package de.intevation.gnv.transition;

import java.io.Serializable;
import java.util.Collection;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import de.intevation.artifacts.CallMeta;
import de.intevation.gnv.transition.exception.TransitionException;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public interface Transition extends Serializable {

    public void setup(Node configuration);

    public Collection<String> reachableTransitions();

    public boolean isTransitionReachable(String transitionID);

    public String getID();

    public String getDescription();

    public boolean validate();

    public void describe(Document document, Node rootNode, CallMeta callMeta, String uuid);

    public void setParent(Transition transition);

    public Transition getParent();

    public Collection<InputValue> getRequiredInputValues();

    public void putInputData(Collection<InputData> inputData, 
                             String uuid)
                                         throws TransitionException;

    public Collection<InputData> getInputData() throws TransitionException;

    public void advance(String uuid, CallMeta callMeta)
                                                       throws TransitionException;

}
